#include "stdafx.h"
#include "pbnioleobject.h"
#include "MyEventSink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CEventSink, CCmdTarget)

CEventSink::CEventSink()
{
	EnableAutomation();
}

CEventSink::~CEventSink()
{
}

void CEventSink::OnFinalRelease()
{
	CCmdTarget::OnFinalRelease();
}

void CEventSink::PassUserData ( LPARAM userData )
{ 
	m_userdata = (UserData*)userData;
}

BEGIN_MESSAGE_MAP(CEventSink, CCmdTarget)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CEventSink, CCmdTarget)
	DISP_FUNCTION(CEventSink, "Startup", Startup, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CEventSink, "Quit", Quit, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CEventSink, "DocumentChange", DocumentChange, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()

static const GUID IID_ICEventSink = {0x000209f7,0x000,0x0000,{0xc0,0x00,0x0,0x00,0x00,0x00,0x00,0x46 } };

BEGIN_INTERFACE_MAP(CEventSink, CCmdTarget)
	INTERFACE_PART(CEventSink, IID_ICEventSink, Dispatch)
END_INTERFACE_MAP()

void CEventSink::Startup() 
{
	//We'll never get this one, it happens before we capture the events
	#ifdef _DEBUG
		MessageBox( NULL, "Startup", "Message", MB_ICONEXCLAMATION | MB_OK );
	#endif

	pbclass clz = m_userdata->session->GetClass(m_userdata->object);
	pbmethodID mid = m_userdata->session->GetMethodID(clz, "startup", PBRT_EVENT, "LUL" );

	PBCallInfo ci;
	m_userdata->session->InitCallInfo(clz, mid, &ci);
	m_userdata->session->TriggerEvent(m_userdata->object, mid, &ci);
	m_userdata->session->FreeCallInfo(&ci);

}

void CEventSink::Quit() 
{
	#ifdef _DEBUG
		MessageBox( NULL, "Quit", "Message", MB_ICONEXCLAMATION | MB_OK );
	#endif

	pbclass clz = m_userdata->session->GetClass(m_userdata->object);
	pbmethodID mid = m_userdata->session->GetMethodID(clz, "quit", PBRT_EVENT, "LUL" );

	PBCallInfo ci;
	m_userdata->session->InitCallInfo(clz, mid, &ci);
	m_userdata->session->TriggerEvent(m_userdata->object, mid, &ci);
	m_userdata->session->FreeCallInfo(&ci);

}

void CEventSink::DocumentChange() 
{
	#ifdef _DEBUG
		MessageBox( NULL, "DocumentChange", "Message", MB_ICONEXCLAMATION | MB_OK );
	#endif

	pbclass clz = m_userdata->session->GetClass(m_userdata->object);
	pbmethodID mid = m_userdata->session->GetMethodID(clz, "documentchange", PBRT_EVENT, "LUL" );

	PBCallInfo ci;
	m_userdata->session->InitCallInfo(clz, mid, &ci);
	m_userdata->session->TriggerEvent(m_userdata->object, mid, &ci);
	m_userdata->session->FreeCallInfo(&ci);

}
