#include "pbnioleobject.h"
#include "MyEventSink.h"

COLEObject::COLEObject()
{	
}

COLEObject::~COLEObject(void)
{
}

enum MethodIDs
{
	CAPTUREEVENTS = 0,
	RELEASEEVENTS = 1,
	STARTUP = 2,
	QUIT = 3,
	DOCUMENTCHANGE = 4,
	ENTRY_COUNT
};

class COLEInitClass {
	public:
		COLEInitClass() {
		OleInitialize(NULL);
	}
		~COLEInitClass() {
		OleUninitialize();
	}
};
COLEInitClass g_OleInitClass;

PBXRESULT COLEObject::Invoke(IPB_Session * session, pbobject obj, pbmethodID mid, PBCallInfo * ci)
{

	ud.session = session;
	ud.object = obj;

	switch( mid )
	{
	case CAPTUREEVENTS:
		{
		int	rc ;
		rc = CaptureEvents ( ) ; 
		ci->returnValue->SetInt((pbint)rc );
		return PBX_OK;
		}
	case RELEASEEVENTS:
		{
		int	rc ;
		rc = ReleaseEvents ( ) ;
		ci->returnValue->SetInt((pbint)rc );
		return PBX_OK;
		}
	case STARTUP:
		{
		return PBX_OK;
		}
	case QUIT:
		{
		return PBX_OK;
		}
	case DOCUMENTCHANGE:
		{
		return PBX_OK;
		}
	}
	return PBX_E_INVOKE_METHOD_AMBIGUOUS;
}

int COLEObject::CaptureEvents()
{

	#ifdef _DEBUG
		char  buffer[256] ;
	#endif

	pbulong	lpDispatch ;
	pbint	rc ;
	pbclass clz = ud.session->GetClass(ud.object);

	PBCallInfo ci;
	pbmethodID mid = ud.session->GetMethodID(clz, "getautomationnativepointer", PBRT_FUNCTION, "IRU" );
	ud.session->InitCallInfo(clz, mid, &ci);
	ud.session->InvokeObjectFunction(ud.object, mid, &ci);
	IPB_Value* pArg0 = ci.pArgs->GetAt(0);
    lpDispatch = pArg0->GetUlong();
	rc = ci.returnValue->GetInt();
	ud.session->FreeCallInfo(&ci);

	#ifdef _DEBUG
		sprintf ( buffer, "GetAuotmationNativePointer Result: %d", lpDispatch );
		MessageBox( NULL, buffer, "Message", MB_ICONEXCLAMATION | MB_OK );
	#endif
	if (lpDispatch==0)
	{
		return PBX_FAIL ;
	}

	m_app.AttachDispatch ( (LPDISPATCH)lpDispatch, TRUE	);

    static const GUID IID_IWord8AppEvents = {0x000209f7,0x000,0x0000,{0xc0,0x00,0x0,0x00,0x00,0x00,0x00,0x46 } };

    HRESULT hr;

    IConnectionPointContainer *pConnPtContainer;
    hr = m_app.m_lpDispatch->QueryInterface(
			IID_IConnectionPointContainer,
			(void **)&pConnPtContainer );
	#ifdef _DEBUG
		sprintf ( buffer, "QueryInferface Result: %d", hr );
		MessageBox( NULL, buffer, "Message", MB_ICONEXCLAMATION | MB_OK );
	#endif
    if (FAILED(hr))
	{
		return PBX_FAIL ;
	};

    hr = pConnPtContainer->FindConnectionPoint(
			IID_IWord8AppEvents,
			&m_pConnectionPoint );
	#ifdef _DEBUG
		sprintf ( buffer, "FindConnectionPoint Result: %d", hr );
		MessageBox( NULL, buffer, "Message", MB_ICONEXCLAMATION | MB_OK );
	#endif
    if (FAILED(hr))
	{
		return PBX_FAIL ;
	}

    LPUNKNOWN pUnk = m_myEventSink.GetInterface(&IID_IUnknown);
	#ifdef _DEBUG
		sprintf ( buffer, "GetInferface Result: %d", pUnk );
		MessageBox( NULL, buffer, "Message", MB_ICONEXCLAMATION | MB_OK );
	#endif
    if (pUnk==0)
	{
		return PBX_FAIL ;
	}

    hr = m_pConnectionPoint->Advise(pUnk, &m_adviseCookie);
	#ifdef _DEBUG
		sprintf ( buffer, "Advise Result: %d", hr );
		MessageBox( NULL, buffer, "Message", MB_ICONEXCLAMATION | MB_OK );
	#endif
    if (FAILED(hr))
	{
		return PBX_FAIL ;
	}

    pConnPtContainer->Release();

	m_myEventSink.PassUserData ((LPARAM)&ud);

	return PBX_OK ;
	
}

int COLEObject::ReleaseEvents() 
{

    if ( m_app.m_lpDispatch == NULL)
	{
		return PBX_FAIL;
    }
    m_pConnectionPoint->Unadvise(m_adviseCookie);

	pbint	rc ;
	pbclass clz = ud.session->GetClass(ud.object);
	PBCallInfo ci;
	pbmethodID mid = ud.session->GetMethodID(clz, "releaseautomationnativepointer", PBRT_FUNCTION, "IRU" );
	ud.session->InitCallInfo(clz, mid, &ci);
	ci.pArgs->GetAt(0)->SetUlong( (pbulong)m_app.m_lpDispatch );
	ud.session->InvokeObjectFunction(ud.object, mid, &ci);
	rc = ci.returnValue->GetInt();
	ud.session->FreeCallInfo(&ci);

	return PBX_OK ;
	
}

void COLEObject::Destroy()
{
	delete this ;
}